# -*- coding: utf-8 -*-
#$Id: __init__.py 131 2006-04-19 10:55:23Z taka $
#############################################################################
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

# Zope call first __init__.py in this product. This file register
# PRODUCT, setup security and roles.

from Products.Archetypes.public import process_types, listTypes
from Products.CMFCore import utils
from Products.CMFCore.DirectoryView import registerDirectory

from permissions import initialize as initialize_permissions
from config import *
##Import tools and utilities here


# Registration all sub-folders under SKINS_DIR as Filesystem Directory
# View.
registerDirectory(SKINS_DIR, GLOBALS)

# 'initialize' is called by Zope for product initialization. In pseudo
# code:
# import Products.ATCTSmallSample
# Products.ATCTSmallSample.initialize(context)
def initialize(context):
    ##Import Types here to register them
    # It's important for import all python modules depend this product to
    # refresh this producut. AND register class object as content type.
    # ATCTSmallSample import all content types in content/__init__.py 
    # then content types registration to Archetypes is executed by import 
    # 'content' only.
    import content

    # Get content type informations ware registerd to Archetypes.  
    # Products.Archetypes.public.process_types() will return 'content 
    # type' list, 'content constructor' list, 'file type 
    # information(FTI)' list.
    content_types, constructors, ftis = process_types(
        listTypes(PROJECTNAME),
        PROJECTNAME)

    # Get permissions depend this product. Definition of permissions is 
    # made at ATCTSmallSample.permissions.
    permissions = initialize_permissions()

    # Make 'content type' and 'constructor' tuples list to use easly at 
    # next process.
    allTypes = zip(content_types, constructors)

    # Registration per content type.
    for atype, constructor in allTypes:
        kind = "%s: %s" % (config.PROJECTNAME, atype.archetype_name)
        # Call CMFCore.utils.ContentInit to register content types.
        utils.ContentInit(
            # Name that display in ADD drop-down menu on ZMI is 
            # specified. This is used as meta_type in internal. However, 
            # there is no relation to meta_type set in each contents type 
            # implementation class.
            kind,

            # The tupple of the contents type implementation class object 
            # that can be added with kind(meta_type) is specified. The 
            # menu panel to select it is displayed to add the object of 
            # which contents type with ZMI when the plural is specified 
            # when the addition is executed.
            content_types      = (atype,),

            # Permission information on the contents type that tries to 
            # be registered now is specified among information acquired 
            # with initialize_permissions().
            permission         = permissions[atype.portal_type],

            # The constructor executed when the object is added is 
            # specified. Constructors of the same number as the number of 
            # elements set to the content_types argument are necessary.
            extra_constructors = (constructor,),

            # FileTypeInformation is specified.
            fti                = ftis,

            # The initialization execution function of ContentInit is 
            # called. After necessary processing is done as CMFCore, the 
            # product registration function to Zope is called.
            ).initialize(context)

