# -*- coding: utf-8 -*-
#$Id: testSmallContent.py 138 2006-05-08 16:02:40Z taka $
#############################################################################
#
#  This program is free software; you can redistribute it and/or modify
#  it under the terms of the GNU General Public License as published by
#  the Free Software Foundation; either version 2 of the License, or
#  (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#  GNU General Public License for more details.
#
#  You should have received a copy of the GNU General Public License
#  along with this program; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
##############################################################################

#
# ATCTSmallSample SmallContent tests
#

# The explanation is omitted about the same to testSetup.py code. Please 
# refer to testSetup.py for details.

import os, sys
if __name__ == '__main__':
    execfile(os.path.join(sys.path[0], 'framework.py'))

from Testing import ZopeTestCase
from Products.ATCTSmallSample.tests.ATCTSSTestCase import ATCTSSTestCase


class TestSmallContent(ATCTSSTestCase):

    def test_SmallContent_IInlineObjectInterface(self):
        """check IInlineObject interface"""
        small = getattr(self.folder, 'small')
        from Products.COREBlog2.interfaces.IInlineObject import IInlineObject
        self.failUnless(IInlineObject.isImplementedBy(small))

    def test_SmallContent_IInlineObjectImprement(self):
        """check IInlineObject implementation"""
        small = getattr(self.folder, 'small')
        self.assertEqual(True, small.isInlineObject())
        self.assertEqual(None, small.getAttachmentView())

        """Can you access skin from the result of getInlineView?"""
        macros = small.getInlineView()
        self.assertEqual(2, len(macros))
        pt = getattr(self.portal, macros[0])
        self.failUnless(pt)

        """PageTemplate has specified macro name?"""
        self.failUnless(macros[1] in pt.pt_macros().keys())



def test_suite():
    from unittest import TestSuite, makeSuite
    suite = TestSuite()
    suite.addTest(makeSuite(TestSmallContent))
    return suite

if __name__ == '__main__':
    framework()
